<?php
namespace WebDB92\Sample;

error_reporting(-1);

if (ini_get('allow_url_fopen') === '') {
    echo 'php.ini で allow_url_fopen が無効化されています', PHP_EOL;
    echo php_ini_loaded_file(), PHP_EOL;
    echo php_ini_scanned_files();
    exit(1);
}

fwrite(STDERR, 'ファイル関数(ストリームラッパー)でHTTPリクエストを行います' . PHP_EOL);


// GETリクエストの例
$query = [
    'fizz' => 'buzz',
    'ほげ' => 'ふが',
];
$get_url = 'http://httpbin.org/get?' . http_build_query($query);
fwrite(STDERR, PHP_EOL . "GET  ${get_url}". PHP_EOL);
$json = file_get_contents($get_url);
var_dump(json_decode($json, true));
echo PHP_EOL;


// POSTリクエストの例
$post_url = 'http://httpbin.org/post';
$form = [
    'fizz' => 'buzz',
    'ほげ' => 'ふが',
];
$body = http_build_query($form);
$headers = [
    'Content-Type: application/x-www-form-urlencoded',
    'Content-Length: ' . strlen($body),
    'User-Agent: PHP/' . PHP_VERSION,
];
$opts = [
    'http' => [
        'method' => 'POST',
        'header' => implode("\r\n", $headers) . "\r\n",
        'content' => $body,
    ]
];
$context = stream_context_create($opts);

fwrite(STDERR, "POST {$post_url}". PHP_EOL);
$json = file_get_contents($post_url, false, $context);
var_dump(json_decode($json, true));
