PHP大規模開発入門 第13回
========================

「PHPからのHTTPリクエスト」のサンプルコードです。

## 1-stream_wrapper.php

`file_get_contents()` を使ったHTTPリクエスト例です。

```
php 1-stream_wrapper.php
```

## 2-curl.php

curlを使ったHTTPリクエスト例です。

```
php 2-curl.php
```

## 3-guzzle.php

Guzzle([guzzle/guzzle](https://github.com/guzzle/guzzle/))を使ったHTTPリクエスト例です。

```
php 3-guzzle.php
```

## 4-api-client.php

Guzzleをベースに開発したAPIクライアント実装を利用する例です。Composer導入後、 `composer install` でインストールする必要があります。

```
php 4-api-client.php
```

### src/SampleAPIClient.php

[httpbin(1): HTTP Client Testing Service](http://httpbin.org/)にリクエストを行うクラスです。

### src/JsonAPIClientTrait.php

[JSON(JavaScript Object Notation)](https://ja.wikipedia.org/wiki/JavaScript_Object_Notation)形式のレスポンスのWebAPIを処理するためのクラスです。ただし、わざと非効率になっている部分があります。

## テスト

[PHPUnit – The PHP Testing Framework](https://phpunit.de/)を使ったAPIクライアントのテストです。 `composer test` または `php ./vendor/bin/phpunit` でテスト実行できます。

これらはGuzzleを使ったテストの簡単な例であり、HTTPを使ったテストのベストプラクティスではないことに気をつけてください。

### tests/APITestBase

二種類のテストクラスの基になるクラスです。

### tests/SampleAPIClientTest.php

実際に http://httpbin.org/ に対してHTTPリクエストを送るテストです。初期状態では失敗するので、自分で修正してみてください。

### tests/SampleAPIClientMockTest.php

こちらはモックを使ったテストです。つまり、実際のHTTP通信は発生しません。

本当にHTTP通信が発生しないか確かめるために、LANケーブルをひっこぬくか、無線LANアダプタのスイッチをOFFにしてみると良いでしょう ヾ(〃＞＜)ﾉﾞ
