<?php
namespace WebDB92\Sample;

use GuzzleHttp\Client;
use GuzzleHttp\Exception\ConnectException;
use GuzzleHttp\HandlerStack;
use GuzzleHttp\Handler\MockHandler;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\Psr7\Response;

/**
 * 実際にHTTPリクエストを行うテストです
 */
class SampleAPIClientTest extends APITestBase
{
    /**
     * @dataProvider dataProviderFor_test
     */
    public function test($expected, array $option)
    {
        $sample_api = $this->getClient();

        $actual = $sample_api->useragent($option);
        $this->assertEquals($expected, $actual);
    }

    public function dataProviderFor_test()
    {
        return [
            [
                'expected' => 'HogeHoge',
                'option' => [
                    'headers' => [
                        'User-Agent' => 'HogeHoge; ' . SampleAPIClient::USER_AGENT,
                    ]
                ]
            ]
        ];
    }

    /**
     * @return \WebDB92\Sample\SampleAPIClient
     */
    protected function getClient($value = null)
    {
        return new SampleAPIClient;
    }
}
